var EXPORTED_SYMBOLS = ["logger"];

const {classes: Cc, interfaces: Ci, utils: Cu} = Components;

Cu.import("resource://gre/modules/XPCOMUtils.jsm");
Cu.import("resource://gre/modules/Services.jsm");
XPCOMUtils.defineLazyModuleGetter(this, "Prefs", "chrome://dslrnotifier2/content/modules/prefs.jsm");

const logFileName = "dslrnotifier_log.txt";
const EOL = /win|os[\/_]?2/i.test(Services.appinfo.OS)?"\r\n":"\n";

var logFile = null;

var logger = function(txt, aForce) {
	// if txt is an error object, log it
	if ((typeof(txt) == "object") && txt.lineNumber) {
		var consoleError = Cc['@mozilla.org/scripterror;1'].createInstance(Ci.nsIScriptError);
		consoleError.init(txt.message, txt.fileName, txt.lineNumber, txt.lineNumber, txt.columnNumber, 0, null);
		txt = consoleError;
		aForce = true;
	}

	if (aForce || Prefs.debug) {
	
		Services.console.logStringMessage("DSLR Notifier - (" + (new Date).toGMTString() + "): " + txt);
		write_log((new Date).toGMTString() + "): " + txt + "\n");
	}
}

var write_log = function(aMessage) {
	try {
		if (!logFile) {
			logFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsILocalFile).clone();
			logFile.append(this.logFileName);
		}
	
		var stream = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
		// ioFlags: write only, create file, append;	Permission: read/write owner
		stream.init(logFile, 0x02 | 0x08 | 0x10, 0600, 0);
		var cvstream = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
		cvstream.init(stream, "UTF-8", 0, Ci.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER);
		
		cvstream.writeString(aMessage.replace(/[\n$]/g, EOL));
		cvstream.flush();
		cvstream.close();
	}
	catch (ex) { 
		Cu.reportError(ex);
	}
}